#include "Hitters.as";
#include "FireParticle.as"

const f32 DAMAGE = 1.0f;
const f32 AOE = 5.0f;//radius

void onInit( CBlob@ this )
{
	this.SetLight( true );
	this.SetLightRadius( 32.0f );
	this.SetLightColor(SColor(255, 255, 240, 171));
	this.getSprite().PlaySound("FireFwoosh.ogg");
	this.getShape().SetStatic(true);
	this.server_SetTimeToDie(0.1f);
	this.getSprite().SetZ(100);

}

void onDie( CBlob@ this )
{
	Vec2f pos = this.getPosition();
	CBlob@[] aoeBlobs;
	CMap@ map = getMap();
	
	if ( getNet().isServer() )
	{
		map.getBlobsInRadius( pos, AOE, @aoeBlobs );
		for ( u8 i = 0; i < aoeBlobs.length(); i++ )
		{
			CBlob@ blob = aoeBlobs[i];
			if ( !getMap().rayCastSolidNoBlobs( pos, blob.getPosition() ) )
				this.server_Hit( blob, pos, Vec2f_zero, DAMAGE, Hitters::fire);
		}
	}
	
	this.getSprite().PlaySound( "FireRoar.ogg" );
	ParticleAnimated( "/FireFlash.png",
				  this.getPosition(), Vec2f(0,0), 0.0f, 1.0f,
				  3,
				  -0.1f, false );				  		
}